% Step test for Model 11 - Cruise Control
% Created by John Hedengren

global u d

% Steady State Initial Conditions for the States
vel_ss = 20;
%h_ss = 0;
%x_ss = [vel_ss;h_ss];
x_ss = [vel_ss];

% Steady State Initial Condition for the Control
u_ss = 1000;

% Brake
% Open Loop Step Change
u = -u_ss;
d = 0;
[t1,x1] = ode15s('cruise',[0 1],x_ss);
% Get final state for the next move
x_f1 = x1(size(t1,1),:); 
offset = t1(size(t1,1),1);

% Incline
% Open Loop Disturbance
u = u_ss;
d = 15 * (2*pi/360);
[t2,x2] = ode15s('cruise',[offset 10+offset],x_f1);
% Get final state for the next move
x_f2 = x2(size(t2,1),:);
offset = t2(size(t2,1),1);

% Coast
% Open Loop Step Change
u = 0;
d = 0;
[t3,x3] = ode15s('cruise',[offset 10+offset],x_f2);
% Get final state for the next move
x_f3 = x3(size(t3,1),:);
offset = t3(size(t3,1),1);

% Accelerate
% Open Loop Step Change
u = u_ss;
d = 0;
[t4,x4] = ode15s('cruise',[offset 10+offset],x_f3);

% Prepare the results for plotting
t = [t1;t2;t3;t4];
vel = [x1(:,1);x2(:,1);x3(:,1);x4(:,1)];
%h = [x1(:,2);x2(:,2);x3(:,2);x4(:,2)];


figure(1);
plot(t,vel);

%figure(2);
%plot(t,h);
